#ifndef _IMAGE_H_
#define _IMAGE_H_

#include <allegro.h>

#include <string>
#include <vector>

struct Image {
    Image(BITMAP *bitmap, std::string file) : bitmap(bitmap), file(file) {}
    
    BITMAP *bitmap;
    std::string file;
};

struct ImageManager {
    std::vector<Image*> images;
    
    ImageManager();
    ImageManager(std::vector<std::string> images);
    ~ImageManager();
    
    Image* GetImage(std::string file);
    void FreeImage(std::string file);
    void FreeAll();
    
private:
    Image* AddImage(std::string file);
};

#endif

