#ifndef _INPUT_H_
#define _INPUT_H_

#include <allegro.h>

#include <string>
#include <vector>

#include "vec2.h"
#include "util.h"

std::string GetWord(BITMAP *buffer, int x, int y, int maxletters, std::string prompt, std::string base = "");
std::string GetWord(BITMAP *buffer, std::string prompt, std::string base = "");
std::string SelectFile(BITMAP *buffer, const char *wildcard, const char *prompt);
bool keyhit(char in);

struct Button {
    Button(Vec2i pos, Vec2i size, std::string name) : upleft(pos), downright(pos+size), name(name) {}
        
    bool Inside(int x, int y) ;
    void Draw(BITMAP *buffer, int x, int y);
        
    std::string GetName();

private:
    Vec2i upleft, downright;
    std::string name;
};

struct Buttons {    
    void AddButton(Button b);
    void AddButton(Vec2i pos, std::string name);
    void DrawButtons(BITMAP *buffer, int x, int y);
    std::string GetButtonUnder(int x, int y);
    
    private:
std::vector<Button> buttons;
};

#endif

