#include "image.h"
#include "debug.h"

using namespace std;

ImageManager::ImageManager() {}

ImageManager::ImageManager(std::vector<std::string> images) {
    for (vector<string>::iterator i = images.begin(); i != images.end(); ++i) {
        if (!AddImage(*i)) {
            DEBUGOUT("Failed to load image \"" << *i << "\"");
        }
    }
}

ImageManager::~ImageManager() {
    FreeAll();
}

Image* ImageManager::GetImage(string file) {
    for(vector<Image*>::iterator i = images.begin(); i != images.end(); ++i) {
        if ((**i).file == file) {
            return *i;
        }
    }
    return AddImage(file);
}

void ImageManager::FreeImage(std::string file) {
    for(vector<Image*>::iterator i = images.begin(); i != images.end(); ++i) {
        if ((**i).file == file) {
            destroy_bitmap((**i).bitmap);
            return;
        }
    }
    DEBUGOUT("Asked to free image \"" << file << "\" but it could not be found");
}

void ImageManager::FreeAll() {
    for(vector<Image*>::iterator i = images.begin(); i != images.end(); ++i) {
        destroy_bitmap((**i).bitmap);
    }
}

Image* ImageManager::AddImage(string file) {
    BITMAP *im = load_bitmap(file.c_str(), NULL);
    if (!im) {
        DEBUGOUT("Failed to load image \"" << file << "\"");
        return NULL;
    }
    
    return new Image(im, file);
}


